var canvas;
var cntx;
var cnvBackBuffer;
var cntxBackBuffer;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousedown touchstart",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });
    
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });
    
    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });
    
    $("#visualisation").on("keydown",function(evt){
        //alert(String.fromCharCode(evt.keyCode));
        handleKeyDown(evt.keyCode);
    });
} 

function initialiseGUI(){
    pc3=document.getElementById("pc3");
    $("#shapeLib").val("blank");
}

function initialValues(){
    DecimalValueColor=BackR;
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    
    
	//Αρχικές τιμές πίνακα
	clearMatrix();
	Matrix0Left=3*fontSize;
	Matrix1Left=NoOfPixels*(fontSize+2)+Matrix0Left;
	PCLeft=540;
	PCTop=MatrixTop+20;
	Matrix2Left=PCLeft+35;
	Matrix2Top=PCTop+25;
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    
    drawFrames();
    drawLogoImage();
    
    var promptColor=LetterColor;
    var promptYCoord=BottomPanelTop+25;
    cnvsWrite(promptColor,fontSize-10,"Arial",msgLeft,promptYCoord,msg1);
    promptYCoord+=20;
    cnvsWrite(promptColor,fontSize-10,"Arial",msgLeft,promptYCoord,msg2);
    promptYCoord+=20;
    cnvsWrite(promptColor,fontSize-10,"Arial",msgLeft,promptYCoord,msg3);

    for(var i=0;i<NoOfPixels;i++){
		cntx.strokeStyle="rgb(0,0,255)";
		cnvsWrite("rgb(0,0,255)",fontSize,"Arial",17,MatrixTop+(i+1)*fontSize,(i+1)+" : ");
		for(var j=0;j<NoOfPixels;j++){
			var colorToUse=DetermineDrawColor(j,i,true);
			cnvsWrite(colorToUse,fontSize,"Arial",Matrix0Left+j*fontSize,MatrixTop+(i+1)*fontSize,""+pixel[j][i]);
		}
	}
    cnvsWrite("rgb(0,0,255)",fontSize,"Arial",4,TopPanelHeight+60,"Σειρά");
    cnvsWrite("rgb(0,0,255)",fontSize,"Arial",140,TopPanelHeight+60,"Bit");
    cnvsWrite("rgb(0,0,255)",fontSize,"Arial",290,TopPanelHeight+60,"Εικονοστοιχεία");
    cnvsWrite("rgb(0,0,255)",fontSize,"Arial",580,TopPanelHeight+60,"Οθόνη");

    drawShowOriginalSwitch();
    
    cntx.drawImage(pc3,PCLeft,PCTop);
	DrawMatrix();
	if(ShowOriginal)DrawSmallMatrix();
}

function drawFrames(){
    cntx.fillStyle="white";
    cntx.strokeStyle="black";
    cntx.beginPath();
    //Περιοχή σχεδίασης
    cntx.fillRect(0,TopPanelHeight,width,height-TopPanelHeight-BottomPanelHeight);
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,TopPanelHeight);
    //κάτω πλαίσιο
    cntx.rect(0,BottomPanelTop,width,BottomPanelHeight);

    cntx.stroke();
    cnvsWrite(LetterColor,32,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
}

function drawLogoImage(){
    cntx.drawImage(imgLogo,logoLeft,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
    drawBasicScreen();
}

function handleMouseMove(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    
	if(MouseOverMatrix1()){
		SelRow=parseInt((mx-Matrix1Left)/fontSize);
		SelCol=parseInt((my-MatrixTop)/fontSize);
	}
	else{
		if(MouseOverMatrix0()){
			SelRow=parseInt((mx-Matrix0Left)/fontSize);
			SelCol=parseInt((my-MatrixTop)/fontSize);
		}
		else{
			SelRow=-1;
			SelCol=-1;
		}
	}
	
    if(mx>=ShowOriginalLeft && mx<ShowOriginalLeft+switchSize && my>=ShowOriginalTop && my<ShowOriginalTop+switchSize){
    	ShowOriginalHover=true;
    }
    else{
    	ShowOriginalHover=false;
    }

    
    drawBasicScreen();
    //console.log("mx="+mx+" , my="+my+" ,infoSwitchHover="+infoSwitchHover+" ,coordSwitchHover="+coordSwitchHover);
}

function handleMouseUp(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
	if(SelRow>=0 && SelCol>=0){
		pixel[SelRow][SelCol]=(1-pixel[SelRow][SelCol]);
	}
	
    if(ShowOriginalHover){
    	ShowOriginal=!ShowOriginal;
    }

    drawBasicScreen();
}

function DrawMatrix(){
	for(var i=0;i<NoOfPixels;i++){
		for(var j=0;j<NoOfPixels;j++){
			cntx.fillStyle=DetermineDrawColor(i,j,false);
			cntx.strokeStyle=cntx.fillStyle;
			if(pixel[i][j]==0){
				if(i==SelRow && j==SelCol){
					cntx.fillRect(Matrix1Left+i*fontSize,MatrixTop+j*fontSize,fontSize+1,fontSize+1);
				}
				else {
					cntx.rect(Matrix1Left+i*fontSize,MatrixTop+j*fontSize,fontSize,fontSize);
				}
			}
			else{
				cntx.fillRect(Matrix1Left+i*fontSize,MatrixTop+j*fontSize,fontSize+1,fontSize+1);
			}
		}
	}
	cntx.stroke();
}

function DrawSmallMatrix(){
	var DotSize=parseInt(fontSize/NoOfPixels);
	cntx.fillStyle="rgb(255,255,255)";
	for(var i=0;i<NoOfPixels;i++){
		for(var j=0;j<NoOfPixels;j++){
			if(pixel[i][j]==1){					
				cntx.fillRect(Matrix2Left+i*DotSize,Matrix2Top+j*DotSize,DotSize,DotSize);					
			}
		}
	}
}

function MouseOverMatrix0(){
	if(mx>=Matrix0Left && mx<=Matrix0Left+2*NoOfPixels*fontSize && my>=MatrixTop && my<=MatrixTop+NoOfPixels*fontSize){
		return true;
	}
	else{
		return false;
	}
}

function MouseOverMatrix1(){
	if(mx>=Matrix1Left && mx<=Matrix1Left+NoOfPixels*fontSize && my>=MatrixTop && my<=MatrixTop+NoOfPixels*fontSize){
		return true;
	}
	else{
		return false;
	}
}

function DetermineDrawColor(i,j,SeparateColors){
	var colorToUse="";
	if(i==SelRow && j==SelCol){
		colorToUse="rgb(170,170,170";
	}
	else{
		if(SeparateColors){
			if(pixel[i][j]==0){
				colorToUse="rgb(0,0,0)";
			}
			else{
				colorToUse="rgb(0,0,255)";
			}
		}
		else{
			colorToUse="rgb(0,0,0)";
		}
	}
	return colorToUse;
}

function clearMatrix(){
	for(var i=0;i<NoOfPixels;i++){
		for(var j=0;j<NoOfPixels;j++){
			pixel[j][i]=0;
		}
	}
}

function inverseMatrix(){
	for(var i=0;i<NoOfPixels;i++){
		for(var j=0;j<NoOfPixels;j++){
			pixel[j][i]=(1-pixel[j][i]);
		}
	}
}

function DefineA(){
	clearMatrix();
	
	pixel[3][0]=1;
	
	pixel[2][1]=1;
	pixel[3][1]=1;		
	pixel[4][1]=1;
	
	pixel[1][2]=1;
	pixel[2][2]=1;
	pixel[4][2]=1;
	pixel[5][2]=1;
	
	pixel[0][3]=1;
	pixel[1][3]=1;
	pixel[5][3]=1;
	pixel[6][3]=1;
	
	pixel[0][4]=1;
	pixel[1][4]=1;
	pixel[5][4]=1;
	pixel[6][4]=1;
	
	pixel[0][5]=1;
	pixel[1][5]=1;
	pixel[2][5]=1;
	pixel[3][5]=1;
	pixel[4][5]=1;
	pixel[5][5]=1;
	pixel[6][5]=1;
	
	pixel[0][6]=1;
	pixel[1][6]=1;
	pixel[5][6]=1;
	pixel[6][6]=1;

	pixel[0][7]=1;
	pixel[1][7]=1;
	pixel[5][7]=1;
	pixel[6][7]=1;
}

function DefineChessBoard(){
	var k=0;
	clearMatrix();
	for(var i=0;i<NoOfPixels;i++){
		k=1-k;
		for(var j=0;j<NoOfPixels;j++){
			pixel[j][i]=k;
			k=1-k;
		}
	}
}

function DefineBullsEye(){
	clearMatrix();
	pixel[2][0]=1;
	pixel[5][0]=1;
	
	pixel[1][1]=1;
	pixel[3][1]=1;
	pixel[4][1]=1;
	pixel[6][1]=1;
	
	pixel[0][2]=1;
	pixel[2][2]=1;
	pixel[5][2]=1;
	pixel[7][2]=1;
	
	pixel[1][3]=1;
	pixel[3][3]=1;
	pixel[4][3]=1;
	pixel[6][3]=1;

	pixel[1][4]=1;
	pixel[3][4]=1;
	pixel[4][4]=1;
	pixel[6][4]=1;

	pixel[0][5]=1;
	pixel[2][5]=1;
	pixel[5][5]=1;
	pixel[7][5]=1;

	pixel[1][6]=1;
	pixel[3][6]=1;
	pixel[4][6]=1;
	pixel[6][6]=1;

	pixel[2][7]=1;
	pixel[5][7]=1;
}

function DefineSmiley(){
	clearMatrix();
	pixel[2][0]=1;
	pixel[3][0]=1;
	pixel[4][0]=1;
	pixel[5][0]=1;
	
	pixel[1][1]=1;
	pixel[6][1]=1;
	
	pixel[0][2]=1;
	pixel[2][2]=1;
	pixel[5][2]=1;
	pixel[7][2]=1;
	
	pixel[0][3]=1;
	pixel[7][3]=1;

	pixel[0][4]=1;
	pixel[2][4]=1;
	pixel[5][4]=1;
	pixel[7][4]=1;

	pixel[0][5]=1;
	pixel[3][5]=1;
	pixel[4][5]=1;
	pixel[7][5]=1;

	pixel[1][6]=1;
	pixel[6][6]=1;

	pixel[2][7]=1;
	pixel[3][7]=1;
	pixel[4][7]=1;
	pixel[5][7]=1;
}

function DefineCross(){
	clearMatrix();
	pixel[1][3]=1;
	pixel[1][4]=1;		
	pixel[2][3]=1;
	pixel[2][4]=1;
	pixel[3][1]=1;
	pixel[3][2]=1;
	pixel[3][3]=1;
	pixel[3][4]=1;		
	pixel[3][5]=1;
	pixel[3][6]=1;
	pixel[4][1]=1;
	pixel[4][2]=1;
	pixel[4][3]=1;
	pixel[4][4]=1;
	pixel[4][5]=1;
	pixel[4][6]=1;
	pixel[5][3]=1;
	pixel[5][4]=1;
	pixel[6][3]=1;
	pixel[6][4]=1;
}

function itemStateChanged(){
	switch($("#shapeLib").val()){
		case "blank":
			clearMatrix();
			break;
		case "alpha":
			DefineA();
			break;
		case "chessboard":
			DefineChessBoard();
			break;
		case "target":
			DefineBullsEye();
			break;
		case "smiley":
			DefineSmiley();
			break;
		case "cross":
			DefineCross();
			break;
	}
	drawBasicScreen();
}

function actionPerformed(slctr){
	if(slctr==0){
		clearMatrix();
		$("#shapeLib").val("blank");
	}
	else if(slctr==1){
		inverseMatrix();
	}
	drawBasicScreen();
}

function drawShowOriginalSwitch(){
    if(ShowOriginalHover){
        cntx.strokeStyle="#0000ff";
        cntx.fillStyle="#ffffff";
    }
    else{
        cntx.strokeStyle="#000000";
        cntx.fillStyle="#e1e1e1";
    }
    cntx.fillRect(ShowOriginalLeft,ShowOriginalTop,switchSize,switchSize);
    cntx.beginPath(); 
    cntx.rect(ShowOriginalLeft,ShowOriginalTop,switchSize,switchSize);
    if(ShowOriginal){
        cntx.moveTo(ShowOriginalLeft+switchSize,ShowOriginalTop+switchSize);
        cntx.lineTo(ShowOriginalLeft,ShowOriginalTop);
        cntx.moveTo(ShowOriginalLeft+switchSize,ShowOriginalTop);
        cntx.lineTo(ShowOriginalLeft,ShowOriginalTop+switchSize);
    }
    cntx.stroke();
    cnvsWrite(LetterColor,fontSize-8,"Arial",ShowOriginalLeft+switchSize+captionPadding,ShowOriginalTop+switchSize,"Εμφάνιση στον υπολογιστή");
}
